﻿using System.Collections.Generic;
using System.Linq;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Mapping;

//Internal namespaces
using ArcGIS.Desktop.Internal.Editing;
using ArcGIS.Desktop.Internal.Mapping;

namespace ParcelFabricSDK
{
  internal class DeleteParcels : Button
  {
    protected async override void OnClick()
    {
      await QueuedTask.Run( () =>
      {
        // check for selected layer
        if (MapView.Active.GetSelectedLayers().Count == 0)
        {
          System.Windows.MessageBox.Show("Please select a source feature layer in the table of contents", "Delete Parcel");
          return;
        }

        //first get the feature layer that's selected in the table of contents
        var theParcelFeatLyr = MapView.Active.GetSelectedLayers().OfType<FeatureLayer>().First();

        if (theParcelFeatLyr == null)
          return;

        var ids = new List<long>(theParcelFeatLyr.GetSelection().GetObjectIDs());

        if (ids.Count == 0)
          return;

        var editOper = new EditOperation()
        {
          Name = "Delete Parcels",
          ProgressMessage = "Delete Parcels...",
          ShowModalMessageAfterFailure = true,
          SelectNewFeatures = false,
          SelectModifiedFeatures = false
        };

        editOper.DeleteParcels(theParcelFeatLyr, ids);
        editOper.Execute();

      });
    }
  }
}
